package com.delfines.business;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import com.delfines.dao.ConnectionFactorySQLAWS;
import com.delfines.vo.AvalBedStatus;
import com.delfines.vo.AvalBusinessDate;
import com.delfines.vo.AvalCategoryStatus;
import com.delfines.vo.Value;

public class OperaRoomBo {
	
	public List<AvalCategoryStatus> listRoomCategoryStatus(){
		List<AvalCategoryStatus> lista = new ArrayList<>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
        try {
        	Connection conn = ConnectionFactorySQLAWS.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" select r.n,MAX(convert(varchar(10),r.business_date,103)) business_date,MAX(dbo.GetDiaSemana(convert(date,r.business_date,103))) dia_semana, ");
            query.append(" SUM(CASE WHEN r.category='DL' THEN r.availability ELSE 0 END) category_dl, ");
            query.append(" SUM(CASE WHEN r.category='EK' THEN r.availability ELSE 0 END) category_ek, ");
            query.append(" SUM(CASE WHEN r.category='ET' THEN r.availability ELSE 0 END) category_et, ");
            query.append(" SUM(CASE WHEN r.category='JS' THEN r.availability ELSE 0 END) category_js, ");
            query.append(" SUM(CASE WHEN r.category='PK' THEN r.availability ELSE 0 END) category_pk, ");
            query.append(" SUM(CASE WHEN r.category='PS' THEN r.availability ELSE 0 END) category_ps, ");
            query.append(" SUM(CASE WHEN r.category='PT' THEN r.availability ELSE 0 END) category_pt, ");
            query.append(" SUM(CASE WHEN r.category='SK' THEN r.availability ELSE 0 END) category_sk, ");
            query.append(" SUM(CASE WHEN r.category='SS' THEN r.availability ELSE 0 END) category_ss, ");
            query.append(" SUM(CASE WHEN r.category='ST' THEN r.availability ELSE 0 END) category_st, ");
            query.append(" SUM(r.capacity) capacity, ");
            query.append(" SUM(r.ocupability) ocupability, ");
            query.append(" SUM(r.availability) availability ");
            query.append(" from dbo.room_availability r where r.austate=1 ");
            query.append(" group by r.n ");
            query.append(" order by r.n ");
            
            ps = conn.prepareStatement(query.toString());
            rs = ps.executeQuery();
            
            while(rs.next()){
            	AvalCategoryStatus obj=new AvalCategoryStatus();
            	obj.setN(rs.getInt("n"));
            	obj.setBusinssDate(rs.getString("business_date"));
            	obj.setDiaSemana(rs.getString("dia_semana"));
            	obj.setAvalCatDL(rs.getInt("category_dl"));
            	obj.setAvalCatEK(rs.getInt("category_ek"));
            	obj.setAvalCatET(rs.getInt("category_et"));
            	obj.setAvalCatJS(rs.getInt("category_js"));
            	obj.setAvalCatPK(rs.getInt("category_pk"));
            	obj.setAvalCatPS(rs.getInt("category_ps"));
            	obj.setAvalCatPT(rs.getInt("category_pt"));
            	obj.setAvalCatSK(rs.getInt("category_sk"));
            	obj.setAvalCatSS(rs.getInt("category_ss"));
            	obj.setAvalCatST(rs.getInt("category_st"));
            	obj.setCapacity(rs.getInt("capacity"));
            	obj.setOcupability(rs.getInt("ocupability"));
            	obj.setAvailability(rs.getInt("availability"));
            	lista.add(obj);
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return lista;
	}
	
	public List<AvalCategoryStatus> listRoomCategoryStatus(Integer n){
		List<AvalCategoryStatus> lista = new ArrayList<>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
        try {
        	Connection conn = ConnectionFactorySQLAWS.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" select r.n,MAX(convert(varchar(10),r.business_date,103)) business_date,MAX(dbo.GetDiaSemana(convert(date,r.business_date,103))) dia_semana, ");
            query.append(" SUM(CASE WHEN r.category='DL' THEN r.availability ELSE 0 END) category_dl, ");
            query.append(" SUM(CASE WHEN r.category='EK' THEN r.availability ELSE 0 END) category_ek, ");
            query.append(" SUM(CASE WHEN r.category='ET' THEN r.availability ELSE 0 END) category_et, ");
            query.append(" SUM(CASE WHEN r.category='JS' THEN r.availability ELSE 0 END) category_js, ");
            query.append(" SUM(CASE WHEN r.category='PK' THEN r.availability ELSE 0 END) category_pk, ");
            query.append(" SUM(CASE WHEN r.category='PS' THEN r.availability ELSE 0 END) category_ps, ");
            query.append(" SUM(CASE WHEN r.category='PT' THEN r.availability ELSE 0 END) category_pt, ");
            query.append(" SUM(CASE WHEN r.category='SK' THEN r.availability ELSE 0 END) category_sk, ");
            query.append(" SUM(CASE WHEN r.category='SS' THEN r.availability ELSE 0 END) category_ss, ");
            query.append(" SUM(CASE WHEN r.category='ST' THEN r.availability ELSE 0 END) category_st, ");
            query.append(" SUM(r.capacity) capacity, ");
            query.append(" SUM(r.ocupability) ocupability, ");
            query.append(" SUM(r.availability) availability ");
            query.append(" from dbo.room_availability r where r.austate=1 ");
            query.append(" and r.n>=? ");
            query.append(" group by r.n ");
            query.append(" order by r.n ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1, n);
            rs = ps.executeQuery();
            
            while(rs.next()){
            	AvalCategoryStatus obj=new AvalCategoryStatus();
            	obj.setN(rs.getInt("n"));
            	obj.setBusinssDate(rs.getString("business_date"));
            	obj.setDiaSemana(rs.getString("dia_semana"));
            	obj.setAvalCatDL(rs.getInt("category_dl"));
            	obj.setAvalCatEK(rs.getInt("category_ek"));
            	obj.setAvalCatET(rs.getInt("category_et"));
            	obj.setAvalCatJS(rs.getInt("category_js"));
            	obj.setAvalCatPK(rs.getInt("category_pk"));
            	obj.setAvalCatPS(rs.getInt("category_ps"));
            	obj.setAvalCatPT(rs.getInt("category_pt"));
            	obj.setAvalCatSK(rs.getInt("category_sk"));
            	obj.setAvalCatSS(rs.getInt("category_ss"));
            	obj.setAvalCatST(rs.getInt("category_st"));
            	obj.setCapacity(rs.getInt("capacity"));
            	obj.setOcupability(rs.getInt("ocupability"));
            	obj.setAvailability(rs.getInt("availability"));
            	lista.add(obj);
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return lista;
	}
	
	public List<AvalBusinessDate> listBusinessDate(){
		List<AvalBusinessDate> lista = new ArrayList<>(); 
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactorySQLAWS.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" select r.n,MAX(convert(varchar(10),r.business_date,103)) business_date,MAX(dbo.GetDiaSemana(convert(date,r.business_date,103))) dia_semana ");
            query.append(" from dbo.room_availability r where r.austate=1 "); 
            query.append(" group by r.n  ");
            query.append(" order by r.n ");
            
            ps = conn.prepareStatement(query.toString());
            rs = ps.executeQuery();
            
            while(rs.next()){
            	StringBuilder item = new StringBuilder();
            	item.append(rs.getString("business_date")).append(" ").append(rs.getString("dia_semana"));
            	AvalBusinessDate obj=new AvalBusinessDate();
            	obj.setN(rs.getInt("n"));
            	obj.setBusinessDate(item.toString());
            	lista.add(obj);
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return lista;
	}
	
	
	/***
	 * 
	 */
	public List<AvalBedStatus> listBedsCategoryStatus(){
		List<AvalBedStatus> lista = new ArrayList<>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
        try {
        	Connection conn = ConnectionFactorySQLAWS.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" select r.n,MAX(convert(varchar(10),r.business_date,103)) business_date,MAX(dbo.GetDiaSemana(convert(date,r.business_date,103))) dia_semana, "); 
            query.append(" SUM(CASE WHEN r.category='0' THEN r.availability ELSE 0 END) aval_0,  ");
            query.append(" SUM(CASE WHEN r.category='1' THEN r.availability*1 ELSE 0 END) aval_1,  ");
            query.append(" SUM(CASE WHEN r.category='2' THEN r.availability*2 ELSE 0 END) aval_2,  ");
            query.append(" SUM(CASE WHEN r.category='3' THEN r.availability*3 ELSE 0 END) aval_3,  ");
            query.append(" SUM(CASE WHEN r.category='4' THEN r.availability*4 ELSE 0 END) aval_4, ");
            
            query.append(" SUM(CASE WHEN r.category='0' THEN r.ocupability ELSE 0 END) ocup_0,  ");
            query.append(" SUM(CASE WHEN r.category='1' THEN r.ocupability*1 ELSE 0 END) ocup_1,  ");
            query.append(" SUM(CASE WHEN r.category='2' THEN r.ocupability*2 ELSE 0 END) ocup_2,  ");
            query.append(" SUM(CASE WHEN r.category='3' THEN r.ocupability*3 ELSE 0 END) ocup_3,  ");
            query.append(" SUM(CASE WHEN r.category='4' THEN r.ocupability*4 ELSE 0 END) ocup_4, ");
            
            query.append(" SUM(r.capacity) capacity,  ");
            query.append(" SUM(r.ocupability) ocupability,  ");
            query.append(" SUM(r.availability) availability  ");
            query.append(" from dbo.bed_availability r where r.austate=1 "); 
            query.append(" group by r.n  ");
            query.append(" order by r.n  ");
            
            ps = conn.prepareStatement(query.toString());
            rs = ps.executeQuery();
            
            while(rs.next()){
            	AvalBedStatus obj=new AvalBedStatus();
            	obj.setN(rs.getInt("n"));
            	obj.setBusinssDate(rs.getString("business_date"));
            	obj.setDiaSemana(rs.getString("dia_semana"));
            	
            	obj.setAvalCat0(rs.getInt("aval_0"));
            	obj.setAvalCat1(rs.getInt("aval_1"));
            	obj.setAvalCat2(rs.getInt("aval_2"));
            	obj.setAvalCat3(rs.getInt("aval_3"));
            	obj.setAvalCat4(rs.getInt("aval_4"));
            	
            	obj.setCapacity(rs.getInt("capacity"));
            	obj.setOcupability(rs.getInt("ocupability"));
            	obj.setAvailability(rs.getInt("availability"));
            	lista.add(obj);
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return lista;
	}
	
	public List<AvalBedStatus> listBedsCategoryStatus(Integer n){
		List<AvalBedStatus> lista = new ArrayList<>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
        try {
        	Connection conn = ConnectionFactorySQLAWS.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" select r.n,MAX(convert(varchar(10),r.business_date,103)) business_date,MAX(dbo.GetDiaSemana(convert(date,r.business_date,103))) dia_semana, "); 
            query.append(" SUM(CASE WHEN r.category='0' THEN r.availability ELSE 0 END) aval_0,  ");
            query.append(" SUM(CASE WHEN r.category='1' THEN r.availability*1 ELSE 0 END) aval_1,  ");
            query.append(" SUM(CASE WHEN r.category='2' THEN r.availability*2 ELSE 0 END) aval_2,  ");
            query.append(" SUM(CASE WHEN r.category='3' THEN r.availability*3 ELSE 0 END) aval_3,  ");
            query.append(" SUM(CASE WHEN r.category='4' THEN r.availability*4 ELSE 0 END) aval_4, ");
            
            query.append(" SUM(CASE WHEN r.category='0' THEN r.ocupability ELSE 0 END) ocup_0,  ");
            query.append(" SUM(CASE WHEN r.category='1' THEN r.ocupability*1 ELSE 0 END) ocup_1,  ");
            query.append(" SUM(CASE WHEN r.category='2' THEN r.ocupability*2 ELSE 0 END) ocup_2,  ");
            query.append(" SUM(CASE WHEN r.category='3' THEN r.ocupability*3 ELSE 0 END) ocup_3,  ");
            query.append(" SUM(CASE WHEN r.category='4' THEN r.ocupability*4 ELSE 0 END) ocup_4, ");
            
            query.append(" SUM(r.capacity) capacity,  ");
            query.append(" SUM(r.ocupability) ocupability,  ");
            query.append(" SUM(r.availability) availability  ");
            query.append(" from dbo.bed_availability r where r.austate=1 ");
            query.append(" and r.n>=? ");
            query.append(" group by r.n  ");
            query.append(" order by r.n  ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1, n);
            rs = ps.executeQuery();
            
            while(rs.next()){
            	AvalBedStatus obj=new AvalBedStatus();
            	obj.setN(rs.getInt("n"));
            	obj.setBusinssDate(rs.getString("business_date"));
            	obj.setDiaSemana(rs.getString("dia_semana"));
            	
            	obj.setAvalCat0(rs.getInt("aval_0"));
            	obj.setAvalCat1(rs.getInt("aval_1"));
            	obj.setAvalCat2(rs.getInt("aval_2"));
            	obj.setAvalCat3(rs.getInt("aval_3"));
            	obj.setAvalCat4(rs.getInt("aval_4"));
            	
            	obj.setCapacity(rs.getInt("capacity"));
            	obj.setOcupability(rs.getInt("ocupability"));
            	obj.setAvailability(rs.getInt("availability"));
            	lista.add(obj);
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return lista;
	}
	
	public List<AvalBusinessDate> listBusinessDateBeds(){
		List<AvalBusinessDate> lista = new ArrayList<>(); 
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactorySQLAWS.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append(" select r.n,MAX(convert(varchar(10),r.business_date,103)) business_date,MAX(dbo.GetDiaSemana(convert(date,r.business_date,103))) dia_semana ");
            query.append(" from dbo.bed_availability r where r.austate=1 "); 
            query.append(" group by r.n  ");
            query.append(" order by r.n ");
            
            ps = conn.prepareStatement(query.toString());
            rs = ps.executeQuery();
            
            while(rs.next()){
            	StringBuilder item = new StringBuilder();
            	item.append(rs.getString("business_date")).append(" ").append(rs.getString("dia_semana"));
            	AvalBusinessDate obj=new AvalBusinessDate();
            	obj.setN(rs.getInt("n"));
            	obj.setBusinessDate(item.toString());
            	lista.add(obj);
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return lista;
	}
	
	public List<Value> listaRoomsDetail(Integer n,String label){
		List<Value> lista = new ArrayList<>(); 
		PreparedStatement ps=null;
		ResultSet rs=null;
		
        try {
        	Connection conn = ConnectionFactorySQLAWS.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            if(label.equals("9")){
            	query.append(" SELECT room,category,n,label,(CASE WHEN n=1 THEN (ISNULL(room_status,'-') +'-'+ ISNULL(hk_status,'-')) ELSE '-' END) status,(CASE label WHEN 1 THEN 'SPL' WHEN 2 THEN 'DBL' WHEN 3 THEN 'TRP' WHEN 4 THEN 'CDP' ELSE '-' END) label_desc FROM dbo.bed_availability_detail where n=? and room_state=0 and austate=1 and label IN (1,2,3,4) order by room ");	
            }else{
            	query.append(" SELECT room,category,n,label,(CASE WHEN n=1 THEN (ISNULL(room_status,'-') +'-'+ ISNULL(hk_status,'-')) ELSE '-' END) status,(CASE label WHEN 1 THEN 'SPL' WHEN 2 THEN 'DBL' WHEN 3 THEN 'TRP' WHEN 4 THEN 'CDP' ELSE '-' END) label_desc FROM dbo.bed_availability_detail where n=? and room_state=0 and austate=1 and label=? order by room ");
            }
            
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1, n);
            if(!label.equals("9")){
            	ps.setString(2, label);	
            }
            rs = ps.executeQuery();
            
            while(rs.next()){
            	Value obj=new Value();
            	obj.setId(rs.getInt("n"));
            	obj.setCodigo(rs.getString("room"));
            	obj.setDescripcion(rs.getString("category"));
            	obj.setDenominacion(rs.getString("label_desc"));
            	obj.setDescEstado(rs.getString("status"));
            	lista.add(obj);
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return lista;
	}
	
	
}


