package com.delfines.business;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

import com.delfines.Constante;
import com.delfines.dao.ConnectionFactorySQLAWS;
import com.delfines.vo.Usuario;

public class UsuarioBo {
	
	public String getDateTime(){
		String fecha=""; 
		
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactorySQLAWS.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT dbo.getDateTimeAMPM(dateadd(HOUR, -5, getdate())) hoy ");
            ps = conn.prepareStatement(query.toString());
            
            rs = ps.executeQuery();
            
            if(rs.next()){
            	fecha=rs.getString("hoy");
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return fecha;
	}
	
	public Usuario loginUsuario(Integer idUsuario){
		Usuario usuario = null;
		
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactorySQLAWS.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT u.id_usuario,u.apellidos_nombres,u.username,u.id_perfil,u.email ");
            query.append("FROM dbo.usuario u ");
            query.append("WHERE u.id_usuario=? ");
                        
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1, idUsuario);
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	usuario=new Usuario();
            	usuario.setIdUsuario(rs.getInt("id_usuario"));
            	usuario.setApellidosNombres(rs.getString("apellidos_nombres"));
            	usuario.setUsername(rs.getString("username"));
            	usuario.setIdPerfil(rs.getInt("id_perfil"));
            	//
            	usuario.setEmail(rs.getString("email"));
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        return usuario;
	}
	
	public Integer validaUsuario(String username,String password){
		Integer idUsuario=0; 
		
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
            
        	Connection conn = ConnectionFactorySQLAWS.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT u.id_usuario,u.apellidos_nombres,u.username FROM usuario u WHERE u.username=? and u.passwd=? ");
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, username);
            ps.setString(2, password);
            
            rs = ps.executeQuery();
            
            if(rs.next()){
            	idUsuario=rs.getInt("id_usuario");
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return idUsuario;
	}
	
	public Integer changePwd(String username,String password)throws Exception{
		PreparedStatement ps=null;
		Integer pk=Constante.ID_INICIAL;
        try {
        	Connection conn = ConnectionFactorySQLAWS.getInstance().getConnection();
        	StringBuilder query = new StringBuilder();
            query.append("UPDATE dbo.usuario SET passwd=? WHERE username=?");
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, password.trim());
            ps.setString(2, username.trim());
            pk=ps.executeUpdate();
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        return pk;
	}
	
	public Integer updateSessionId(Integer id,String sessionId,Integer estadoSession)throws Exception{
		PreparedStatement ps=null;
		Integer pk=Constante.ID_INICIAL;
        try {
        	Connection conn = ConnectionFactorySQLAWS.getInstance().getConnection();
        	StringBuilder query = new StringBuilder();
            query.append("UPDATE dbo.usuario SET session_id=?, session_valid=?,audit_fechahora=getdate() WHERE id_usuario=? and estado=1");
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, sessionId);
            ps.setInt(2, estadoSession);
            ps.setInt(3, id);
            pk=ps.executeUpdate();
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        return pk;
	}
	
	
	public String getSessionIdValid(Integer id){
		String sessionId=""; 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
        try {
            
        	Connection conn = ConnectionFactorySQLAWS.getInstance().getConnection();
            StringBuilder query = new StringBuilder();
            query.append("SELECT u.session_id FROM usuario u WHERE u.id_usuario=? and u.session_valid=1 ");
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1,id);
            rs = ps.executeQuery();
            
            if(rs.next()){
            	sessionId=rs.getString("session_id");
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        return sessionId;
	}
	
	public String getSessionId(Integer id){
		String sessionId=""; 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
        try {
            
        	Connection conn = ConnectionFactorySQLAWS.getInstance().getConnection();
            StringBuilder query = new StringBuilder();
            query.append("SELECT u.session_id FROM usuario u WHERE u.id_usuario=? ");
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1,id);
            rs = ps.executeQuery();
            
            if(rs.next()){
            	sessionId=rs.getString("session_id");
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        return sessionId;
	}
	
	
}
