package com.delfines.spring.controller;

import javax.servlet.http.HttpServletRequest;

import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;

import com.delfines.Constante;
import com.delfines.business.UsuarioBo;
import com.delfines.vo.Usuario;

@Controller
public class InitController {
   
   //@RequestMapping(path={"/"},method=RequestMethod.GET)
   //public String validate(@RequestParam("action") String action,@RequestParam("ui") Integer id,Model model,HttpServletRequest request) {
   @RequestMapping(path={"/"},method=RequestMethod.GET)	
   public String root(Model model,HttpServletRequest request) {//--
	   String action="root";//--
	   Integer id=9999;//--
	   String target="login";
	   try{
		   if(action!=null&&action.equalsIgnoreCase("validate")){
			   String sessionId=request.getSession().getId();
			   if(sessionId!=null&&sessionId.trim().length()>0){
				   UsuarioBo usuarioBo=new UsuarioBo();
				   String userSessionId=usuarioBo.getSessionId(id);
				   if(userSessionId!=null&&userSessionId.trim().length()>0){
					   if(sessionId.equals(userSessionId)){
						   Integer updated=usuarioBo.updateSessionId(id,sessionId,Constante.ESTADO_ACTIVO);
						   if(updated>0){
							   Usuario usuario=usuarioBo.loginUsuario(id);
							   request.getSession().setAttribute("p_usuario",usuario);
							   target="validate";
						   }else{
							 //las sessiones estan desactivadas
							   request.getSession().setAttribute("p_usuario",new Usuario());
							   target="login";
							   request.getSession().setAttribute("message","Session de usuario desactivado, solicite la asistencia de su administrador de sistema!");
						   }
					   }else{
						   //las sessiones de usuario browser y la session de la BD son diferentes
						   Integer updated=usuarioBo.updateSessionId(id,sessionId,Constante.ESTADO_ACTIVO);
						   if(updated>0){
							   Usuario usuario=usuarioBo.loginUsuario(id);
							   request.getSession().setAttribute("p_usuario",usuario);
							   target="validate";
						   }else{
							 //las sessiones estan desactivadas
							   request.getSession().setAttribute("p_usuario",new Usuario());
							   target="login";
							   request.getSession().setAttribute("message","Session de usuario desactivado, solicite la asistencia de su administrador de sistema!");
						   }
					   }
				   }else{
					   //si la session en bd esta en nulo
					   Integer updated=usuarioBo.updateSessionId(id,sessionId,Constante.ESTADO_ACTIVO);
					   if(updated>0){
						   Usuario usuario=usuarioBo.loginUsuario(id);
						   request.getSession().setAttribute("p_usuario",usuario);
						   target="validate";
					   }else{
						 //las sesion no se actualiza en el usuario de la DB
						   request.getSession().setAttribute("p_usuario",new Usuario());
						   target="login";
						   request.getSession().setAttribute("message","Session de usuario desactivado, solicite la asistencia de su administrador de sistema!");
					   }
				   }
			   }else{
				   //las sessiones estan desactivadas
				   request.getSession().setAttribute("p_usuario",new Usuario());
				   request.getSession().setAttribute("message","Session de usuario desactivado, solicite la asistencia de su administrador de sistema!");
			   }
		   }else{
			   request.getSession().removeAttribute("p_usuario");   
		   }
	   }catch(Exception e){
		   e.printStackTrace();
	   }
       return target;
   }
   
   //validate
   @RequestMapping(path={"/validateui"},method=RequestMethod.GET)
   public String validate(@RequestParam("ui") Integer id,Model model,HttpServletRequest request)throws Exception {
	   String target="login";
	   request.getSession().setAttribute("message","");
	   try{
		   String sessionId=request.getSession().getId();
		   if(sessionId!=null&&sessionId.trim().length()>0){
			   UsuarioBo usuarioBo=new UsuarioBo();
			   String userSessionId=usuarioBo.getSessionId(id);
			   if(userSessionId!=null&&userSessionId.trim().length()>0){
				   if(sessionId.equals(userSessionId)){
					   Integer updated=usuarioBo.updateSessionId(id,sessionId,Constante.ESTADO_ACTIVO);
					   if(updated>0){
						   Usuario usuario=usuarioBo.loginUsuario(id);
						   request.getSession().setAttribute("p_usuario",usuario);
						   target="validate";
					   }else{
						 //las sessiones estan desactivadas
						   request.getSession().setAttribute("p_usuario",new Usuario());
						   target="login";
						   request.getSession().setAttribute("message","Session de usuario desactivado, solicite la asistencia de su administrador de sistema!");
					   }
				   }else{
					   //las sessiones de la base de datos y la sesion del browser son diferentes
					   Integer updated=usuarioBo.updateSessionId(id,sessionId,Constante.ESTADO_ACTIVO);
					   if(updated>0){
						   Usuario usuario=usuarioBo.loginUsuario(id);
						   request.getSession().setAttribute("p_usuario",usuario);
						   target="validate";
					   }else{
						 //las sessiones estan desactivadas
						   request.getSession().setAttribute("p_usuario",new Usuario());
						   target="login";
						   request.getSession().setAttribute("message","Session de usuario desactivado, solicite la asistencia de su administrador de sistema!");
					   }
				   }
			   }else{
				   //si la session en bd esta en nulo
				   Integer updated=usuarioBo.updateSessionId(id,sessionId,Constante.ESTADO_ACTIVO);
				   if(updated>0){
					   Usuario usuario=usuarioBo.loginUsuario(id);
					   request.getSession().setAttribute("p_usuario",usuario);
					   target="validate";
				   }else{
					 //las sessiones estan desactivadas
					   request.getSession().setAttribute("p_usuario",new Usuario());
					   target="login";
					   request.getSession().setAttribute("message","Session de usuario desactivado, solicite la asistencia de su administrador de sistema!");
				   }
			   }
		   }else{
			   //las sessiones estan desactivadas
			   request.getSession().setAttribute("p_usuario",new Usuario());
			   request.getSession().setAttribute("message","Session de usuario desactivado, solicite la asistencia de su administrador de sistema!");
		   }
	   }catch(Exception e){
		   e.printStackTrace();
	   }
       return target;
   }
   
   @RequestMapping(path={"/validate"},method=RequestMethod.GET)
   public String validate(Model model,HttpServletRequest request)throws Exception {
	   
	   String target="login";
	   request.getSession().setAttribute("message","");
	   Integer id=1;//user test
	   try{
		   String ui = request.getParameter("ui");
		   try{
			   if(ui!=null){
				   id=Integer.valueOf(ui);
			   }
		   }catch(Exception e){
			   id=1;
		   }
		   
		   UsuarioBo usuarioBo=new UsuarioBo();
		   String sessionId=request.getSession().getId();
		   Integer updated=usuarioBo.updateSessionId(id,sessionId,Constante.ESTADO_ACTIVO);
		   if(updated>0){
			   Usuario usuario=usuarioBo.loginUsuario(id);
			   request.getSession().setAttribute("p_usuario",usuario);
			   target="validate";
		   }else{
			 //las sessiones estan desactivadas
			   request.getSession().setAttribute("p_usuario",new Usuario());
			   target="login";
			   request.getSession().setAttribute("message","Session de usuario desactivado, solicite la asistencia de su administrador de sistema!");
		   }
		   
	   }catch(Exception e){
		   e.printStackTrace();
	   }
       return target;
   }
   
}
