package com.delfines.spring.controller;

import java.io.File;
import java.io.FileInputStream;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Iterator;

import org.apache.poi.openxml4j.util.ZipSecureFile;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.xssf.usermodel.XSSFSheet;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;

import com.delfines.business.Util;
import com.delfines.dao.ConnectionFactoryOperaBat;

public class ReadExcelDatPlaninDH {

	private String fileOutlHjTrb="\\\\10.0.0.11\\De Paso\\HK\\Dat_PlaninDH.xlsx";
	
	
	public static void main(String[] args) {
	   try{
		   DateFormat dateFormat = new SimpleDateFormat("yyyy/MM/dd HH:mm:ss");
		   Calendar cal = Calendar.getInstance();
		   
		   System.out.println("Init Dat_PlaninDH "+dateFormat.format(cal.getTime()));
		   ReadExcelDatPlaninDH load=new ReadExcelDatPlaninDH();
		   load.deleteOutlHjtrb();
		   System.out.println("Deleted Dat_PlaninDH ");
		   load.insertSqlOutlHjTrb();
		   System.out.println("Inserted Dat_PlaninDH ");
		   
		   /***
		    * Load to SQL Server
		    */
		   LoadDataBedsOpera2SQLAWS loadSQL=new LoadDataBedsOpera2SQLAWS();
		   Integer qty=loadSQL.loadAvailabilityBeds(45);
		   if(qty>0){
			   qty=loadSQL.loadDetailsRoomAvailBeds(45);
			   if(qty>0){
				   loadSQL.enableBedAvailability();   
			   }
		   }
		   
		   cal = Calendar.getInstance();
		   System.out.println("Inserted Beds Availability "+dateFormat.format(cal.getTime())+" "+qty);
		   
	   }catch(Exception e){
		   e.printStackTrace();
	   }
	}
	
	public void insertSqlOutlHjTrb() throws RuntimeException {
		try {
			String file=this.fileOutlHjTrb;
			File excelFile = new File(file);
			FileInputStream fis = new FileInputStream(excelFile);
			ZipSecureFile.setMinInflateRatio(-1.0d);
			// we create an XSSF Workbook object for our XLSX Excel File
			XSSFWorkbook workbook = new XSSFWorkbook(fis);
			// we get first sheet
			XSSFSheet sheet = workbook.getSheet("TipHab");

			// Get iterator to all the rows in current sheet
			Iterator<Row> rowIterator = sheet.iterator();

			// Row Header
			if (rowIterator.hasNext()) {
				rowIterator.next();
			}
			
			// Traversing over each row of XLSX file
			while (rowIterator.hasNext()) {
				StringBuffer sql = new StringBuffer();
				Row row = rowIterator.next();
					//Cell cell = cellIterator.next();
					String room = row.getCell(1).toString();
					Integer valid = Util.toInteger(row.getCell(2).toString());
					Integer camas = Util.toInteger(row.getCell(3).toString());
				sql.append("INSERT INTO TRAINING.HLD_DAT_PLANINDH(ROOM,VALID,CAMA) VALUES ('").append(room).append("',").append(valid).append(",").append(camas).append(")");
				
				insertarOutlHjtrb(sql.toString());
			}
		} catch (Exception e) {
			e.printStackTrace();
			throw new RuntimeException(e);
		}
	}
	
	public void insertarOutlHjtrb(String query){
		PreparedStatement ps=null;
        try {
        	Connection conn = ConnectionFactoryOperaBat.getInstance().getConnection();
        	conn.setAutoCommit(false);
            ps = conn.prepareStatement(query);
            ps.executeUpdate();
            conn.commit();
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
        }
	}
	
	public void deleteOutlHjtrb(){
		StringBuffer sql = new StringBuffer();
		sql.append("TRUNCATE TABLE TRAINING.HLD_DAT_PLANINDH");
		
		PreparedStatement ps=null;
        try {
        	Connection conn = ConnectionFactoryOperaBat.getInstance().getConnection();
        	conn.setAutoCommit(false);
        	ps=conn.prepareStatement(sql.toString());
        	ps.executeUpdate();
        	conn.commit();
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
        }
	}
	
	
}
