package com.delfines.spring.controller;

import java.net.MalformedURLException;
import java.net.URL;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;

import com.delfines.Constante;
import com.delfines.business.UsuarioBo;
import com.delfines.sendmail.SendEmail;
import com.delfines.vo.Usuario;

/**
 * @author imssbora
 */
@Controller
public class UsuarioController {
   
   @RequestMapping(path={"/login-usuario"},method=RequestMethod.GET)
   @ResponseBody
   public String loginUsuario(String username,String passwd,Model model,HttpServletRequest request) throws Exception {
	   UsuarioBo usuarioBo=new UsuarioBo();
	   String target="login";
	   request.getSession().setAttribute("message","");
	   
	   Integer pk=usuarioBo.validaUsuario(username, passwd);
	   Usuario usuario=null;
	   
	   if(pk>0){
		   usuario=usuarioBo.loginUsuario(pk);
		   //fake:inicio
		   //request.getSession().setAttribute("p_usuario",usuario);
		   //target="rooms";
		   //fake:fin
		   if(usuario!=null&&usuario.getIdUsuario()>0){
			   String sessionId=request.getSession().getId();
			   if(sessionId!=null&&sessionId.trim().length()>0){
				   
				   String userSessionId=usuarioBo.getSessionIdValid(pk);
				   if(userSessionId!=null&&userSessionId.trim().length()>0){
					   if(userSessionId.equals(sessionId)){
						   request.getSession().setAttribute("p_usuario",usuario);
						   
						   String section=(String)request.getSession().getAttribute("section");
						   if(section!=null&&section.trim().length()>0){
							   target=section;   
						   }
					   }else{
						   Integer updated=usuarioBo.updateSessionId(pk, sessionId,Constante.ESTADO_ELIMINADO);
						   if(updated>0){
							   //-------------------------Send Email Alert
					    		String fechaHoraHoy=usuarioBo.getDateTime();
					    		String subject="Solicitud de acceso a disponibilidad de habitaciones "+fechaHoraHoy;
					    		String text="Para verificar su identidad y realizar la confirmacion ingrese al siguiente enlace: ";
					    		
					    		String url=getURLBase(request);
					    		//get the time stamp
				                String timestamp = String.valueOf(System.currentTimeMillis());
					    		String path = url+request.getContextPath()+"?action=validate&ui="+pk+"&si="+timestamp;
					    		
					    		path = "<a href='"+path+"' target='_blank'>Valida Acceso</a>";
					    		
					    		text=text+path;
					    		String toList=usuario.getEmail();
					    		String ccList="cchaucca@losdelfineshotel.com.pe";
					    		SendEmail.sendEmailLead(toList, ccList, subject, text);
					    		target="login";
					    		
					    		request.getSession().setAttribute("message","Se envia un correo de validacion de acceso!");
					    		//-------------------------
						   }else{
							   request.getSession().setAttribute("p_usuario",new Usuario());
							   target="login";
							   request.getSession().setAttribute("message","Session de usuario desactivado, solicite la asistencia de su administrador de sistema!");
						   }
					   }
				   }else{
					   //es nuevo se debe registrar el session ID 
					   //Se envia un correo con la solicitud de confirmacion
					   //Se valida la session ID
					   Integer updated=usuarioBo.updateSessionId(pk, sessionId,Constante.ESTADO_ELIMINADO);
					   if(updated>0){
						   //-------------------------Send Email Alert
				    		String fechaHoraHoy=usuarioBo.getDateTime();
				    		String subject="Solicitud de acceso a disponibilidad de habitaciones "+fechaHoraHoy;
				    		String text="Para verificar su identidad y realizar la confirmacion ingrese al siguiente enlace ";
				    		
				    		String url=getURLBase(request);
				    		//get the time stamp
			                String timestamp = String.valueOf(System.currentTimeMillis());
				    		String path = url+request.getContextPath()+"?action=validate&ui="+pk+"&si="+timestamp;
				    		
				    		path = "<a href='"+path+"' target='_blank'>Valida Acceso</a>";
				    		
				    		text=text+path;
				    		String toList=usuario.getEmail();
				    		String ccList="cchaucca@losdelfineshotel.com.pe";
				    		SendEmail.sendEmailLead(toList, ccList, subject, text);
				    		target="login";
				    		
				    		request.getSession().setAttribute("message","Se envia un correo de validacion de acceso!");
				    		//-------------------------
					   }else{
						   request.getSession().setAttribute("p_usuario",new Usuario());
						   target="login";
						   request.getSession().setAttribute("message","Session de usuario desactivado, solicite la asistencia de su administrador de sistema!");
					   }
				   }
			   }else{
				   //las sessiones estan desactivadas
				   request.getSession().setAttribute("p_usuario",new Usuario());
				   target="login";
				   request.getSession().setAttribute("message","Session de usuario desactivado, solicite la asistencia de su administrador de sistema!");
			   }
		   }else{
			   request.getSession().setAttribute("p_usuario",new Usuario());
			   target="login";
			   request.getSession().setAttribute("message","Usuario no registrado o Password incorrecto!");
		   }
		   
	   }else{
		   request.getSession().setAttribute("p_usuario",new Usuario());
		   target="login";
		   request.getSession().setAttribute("message","Usuario no registrado o Password incorrecto!");
	   }
       return target;
   }
   
   public String getURLBase(HttpServletRequest request) throws MalformedURLException {
	    URL requestURL = new URL(request.getRequestURL().toString());
	    String port = requestURL.getPort() == -1 ? "" : ":" + requestURL.getPort();
	    return requestURL.getProtocol() + "://" + requestURL.getHost() + port;
   }
   
   @RequestMapping(path={"/change-pwd"},method=RequestMethod.GET)
   public String changePwd(Model model,HttpServletRequest request) {
	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
	   if(pUsuario!=null&&pUsuario.getIdUsuario()>0){
	       return "change-pwd";
	   }else{
		   return "login";
	   }
   }
   
   @RequestMapping(path={"/guardar-change"},method=RequestMethod.GET)
   @ResponseBody
   public String guardarChange(Integer idUsuario,String password1,String password2,Model model,HttpServletRequest request)throws Exception {
	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
	   String target="login";
	   Integer updated=Constante.ID_INICIAL;
	   if(pUsuario!=null&&pUsuario.getIdUsuario()>0){
		   UsuarioBo bo=new UsuarioBo();
		   updated=bo.changePwd(pUsuario.getUsername(), password1);
		   if(updated>0){
			   String section=(String)request.getSession().getAttribute("section");
			   if(section!=null&&section.trim().length()>0){
				   target=section;   
			   }
		   }else{
			   throw new Exception("No se realiz el cambio del Password!");
		   }
	   }
	   return target;
   }
   
   @RequestMapping(path={"/salir-change"},method=RequestMethod.GET)
   @ResponseBody
   public String salirChange(Integer idUsuario,String password1,String password2,Model model,HttpServletRequest request) {
	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
	   String target="login";
	   if(pUsuario!=null&&pUsuario.getIdUsuario()>0){
		   request.getSession().removeAttribute("p_usuario");
		   String section=(String)request.getSession().getAttribute("section");
		   if(section!=null&&section.trim().length()>0){
			   target=section;   
		   }
	   }
	   return target;
   }
   
}
